# Sanity Plugin Gatsby Deploy

Simple plugin to build and view sites hosted on Gatsby Cloud.
This package provides a [Sanity dashboard widget](https://www.sanity.io/docs/installing-and-configuring-widgets) which triggers builds and within Gatsby Cloud.

## Installation

```bash
yarn add @dotdev/sanity-plugin-gatsby-deploy
# or
npm i @dotdev/sanity-plugin-gatsby-deploy --save
```

Add the plugin to the `plugins` array in `sanity.json`.

```json
"plugins": [
  // ...rest of plugins
  "@dotdev/sanity-plugin-gatsby-deploy"
]
```

If you have not already, append the following to the `parts` array in `sanity.json`.

```json
{
  "implements": "part:@sanity/dashboard/config",
  "path": "dashboardConfig.js"
}
```

Create the file `dashboardConfig.js` and include the widget like this.

```js
export default {
  widgets: [
    {
      name: "gatsby-deploy",
      options: {
        sites: [
          {
            title: "Staging",
            url: "https://preview-yoursite.gtsb.io/",
            webhook: "https://webhook.gatsbyjs.com/hooks/data_source/...",
          },
          {
            title: "Production",
            url: "https://yoursite.com/",
            webhook: "https://webhook.gatsbyjs.com/hooks/data_source/publish/...",
          },
        ],
      },
    },
  ],
}
```

## Configuration

The plugin can be configured through `<your-studio-folder>/config/gatsby-deploy.json`:

```json
{
  "sites": [
    {
      "title": "Staging",
      "url": "https://preview-yoursite.gtsb.io/",
      "webhook": "https://webhook.gatsbyjs.com/hooks/data_source/..."
    },
    {
      "title": "Production",
      "url": "https://yoursite.com/",
      "webhook": "https://webhook.gatsbyjs.com/hooks/data_source/publish/..."
    }
  ]
}
```

## License

MIT © DotDev
See LICENSE
