"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Widget = void 0;

var _react = _interopRequireWildcard(require("react"));

var axios = _interopRequireWildcard(require("axios"));

var _default = _interopRequireDefault(require("part:@sanity/components/buttons/default"));

var _radio = _interopRequireDefault(require("part:@sanity/components/selects/radio"));

var _configGatsbyDeploy = _interopRequireDefault(require("config:gatsby-deploy"));

var _Widget = _interopRequireDefault(require("./Widget.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Widget = () => {
  var _sites$;

  var sites = (_configGatsbyDeploy.default === null || _configGatsbyDeploy.default === void 0 ? void 0 : _configGatsbyDeploy.default.sites) || [];

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      deployed = _useState2[0],
      setDeployed = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1];

  var _useState5 = (0, _react.useState)((_sites$ = sites[0]) === null || _sites$ === void 0 ? void 0 : _sites$.title),
      _useState6 = _slicedToArray(_useState5, 2),
      site = _useState6[0],
      setSite = _useState6[1];

  var currentSite = sites === null || sites === void 0 ? void 0 : sites.find(_ref => {
    var title = _ref.title;
    return title === site;
  });

  var handleChange = _ref2 => {
    var title = _ref2.title;
    return setSite(title);
  };

  var handleOpen = () => {
    window.open(currentSite === null || currentSite === void 0 ? void 0 : currentSite.url, "_blank");
  };

  var handleSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator(function* () {
      setLoading(true); // @ts-ignore

      yield axios.post(currentSite === null || currentSite === void 0 ? void 0 : currentSite.webhook, {
        crossDomain: true
      });
      setLoading(false);
      setDeployed(true);
    });

    return function handleSubmit() {
      return _ref3.apply(this, arguments);
    };
  }();

  (0, _react.useEffect)(() => {
    setDeployed(false);
  }, [site]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _Widget.default.container
  }, /*#__PURE__*/_react.default.createElement("header", {
    className: _Widget.default.header
  }, /*#__PURE__*/_react.default.createElement("h2", {
    className: _Widget.default.title
  }, "Deployments"), /*#__PURE__*/_react.default.createElement("svg", {
    width: "40",
    height: "40",
    viewBox: "0 0 24 24",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/_react.default.createElement("path", {
    d: "M21.4286 12H15.4286V13.7143H19.5429C18.9429 16.2857 17.0572 18.4286 14.5715 19.2857L4.71433 9.42855C5.7429 6.42855 8.65719 4.2857 12 4.2857C14.5715 4.2857 16.8858 5.57141 18.3429 7.54284L19.6286 6.42855C17.9143 4.11427 15.1715 2.57141 12 2.57141C7.5429 2.57141 3.77147 5.74284 2.82861 9.94284L14.1429 21.2571C18.2572 20.2286 21.4286 16.4571 21.4286 12Z",
    fill: "white"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M2.57153 12.0857C2.57153 14.4857 3.51439 16.8 5.31439 18.6C7.11439 20.4 9.51439 21.3428 11.8287 21.3428L2.57153 12.0857Z",
    fill: "white"
  }), /*#__PURE__*/_react.default.createElement("path", {
    fillRule: "evenodd",
    clipRule: "evenodd",
    d: "M12 0C5.4 0 0 5.4 0 12C0 18.6 5.4 24 12 24C18.6 24 24 18.6 24 12C24 5.4 18.6 0 12 0ZM5.31429 18.6857C3.51429 16.8857 2.57143 14.4857 2.57143 12.1714L11.9143 21.4286C9.51429 21.3429 7.11429 20.4857 5.31429 18.6857ZM2.82857 9.94286L14.0571 21.1714C18.2571 20.2286 21.4286 16.4571 21.4286 12H15.4286V13.7143H19.5429C18.9429 16.2857 17.0571 18.4286 14.5714 19.2857L4.71429 9.42857C5.82857 6.42857 8.65714 4.28571 12 4.28571C14.5714 4.28571 16.8857 5.57143 18.3429 7.54286L19.6286 6.42857C17.9143 4.11429 15.1714 2.57143 12 2.57143C7.54286 2.57143 3.77143 5.74286 2.82857 9.94286Z",
    fill: "#663399"
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: _Widget.default.content
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _Widget.default.select
  }, /*#__PURE__*/_react.default.createElement(_radio.default, {
    disabled: loading,
    items: sites,
    onChange: handleChange,
    value: sites.find(_ref4 => {
      var title = _ref4.title;
      return title === site;
    })
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: _Widget.default.footer
  }, /*#__PURE__*/_react.default.createElement(_default.default, {
    bleed: true,
    color: "primary",
    kind: "simple",
    onClick: handleOpen
  }, "View ", site), /*#__PURE__*/_react.default.createElement(_default.default, {
    disabled: loading || deployed,
    color: "primary",
    bleed: true,
    kind: "simple",
    onClick: handleSubmit
  }, deployed ? "Deployment triggered" : "Deploy ".concat(site))));
};

exports.Widget = Widget;
//# sourceMappingURL=Widget.js.map